package tools.descartes.prisma.agent.wildfly.callstack;

import java.util.Collection;
import java.util.Collections;

public abstract class InterfaceRecord {

	private final TraceFactory factory;
	private final String interf;
	private final ComponentRecord component;
	
	public InterfaceRecord(ComponentRecord component, String interf) {
		this.factory = component.getTraceFactory();
		this.component = component;
		this.interf = interf;
	}
	
	public String getInterfaceName() {
		return interf;
	}
	
	public ComponentRecord getComponent() {
		return component;
	}	
				
	public Collection<OperationRecord> getOperations() {
		return Collections.emptyList();
	}
	
	public TraceFactory getTraceFactory() {
		return factory;
	}

	public abstract OperationRecord requireOperation(String operation);
	
	public abstract boolean isFiltered();
	
	public abstract void accept(TraceVisitor visitor, InvocationGroupRecord source);

}
