package tools.descartes.prisma.agent.wildfly.filters;

import java.util.regex.Pattern;

public class InterfacePredicate {
	
	private final Pattern componentPattern;
	private final Pattern interfacePattern;
	
	public InterfacePredicate(String componentRegex, String interfaceRegex) {
		this.componentPattern = Pattern.compile(componentRegex);
		this.interfacePattern = Pattern.compile(interfaceRegex);
	}

	public boolean apply(String component, String interf) {
//		System.err.println("Filter interface: " + component + interf);
		if (componentPattern.matcher(component).matches()) {
			return interfacePattern.matcher(interf).matches();
		}
		return false;
	}
}
