package tools.descartes.prisma.core.scopes;

import tools.descartes.prisma.core.ModelRepository;

public class ScopeFactory {

	public static Scope createScope(ModelRepository repository, SystemGlobalScope systemScope, String path) {
		String[] parts = path.split("/");
		if (parts.length == 2) {
			switch (parts[0]) {
			case ApplicationScope.APPLICATION_SCOPE_TYPE:
				return new ApplicationScope(parts[1], systemScope, repository);
			case UsageProfileScope.USAGE_PROFILE_SCOPE_TYPE:
				return new UsageProfileScope(parts[1], systemScope, repository);
			case PhysicalInfrastructureScope.PHYSICAL_INFRASTRUCTURE_SCOPE_TYPE:
				return new PhysicalInfrastructureScope(parts[1], systemScope, repository);
			case VirtualInfrastructureScope.VIRTUAL_INFRASTRUCTURE_SCOPE_TYPE:
				return new VirtualInfrastructureScope(parts[1], systemScope, repository);
			case PlatformScope.PLATFORM_SCOPE_TYPE:
				return new PlatformScope(parts[1], systemScope, repository);
			}
		} else if (parts.length == 1) {
			if (parts[0].equals(systemScope.getName())) {
				return systemScope;
			}
		}
		return null;
	}

}
